package com.xydl.cac.controller;

import com.xydl.cac.entity.Bdz;
import com.xydl.cac.entity.IcdConfigTypeInst;
import com.xydl.cac.model.Response;
import com.xydl.cac.service.ParamBindService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.repository.query.Param;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.constraints.NotNull;
import java.util.List;

@RestController
@Api(tags = {"参数绑定相关接口"})
@RequestMapping("parambind")
@Slf4j
public class ParamBindController extends BasicController {

    @Resource
    ParamBindService bindService;

    @GetMapping("getTree")
    @ApiOperation("查询树")
    public Response<List<Bdz>> getTree() throws Exception {
        List<Bdz> result = bindService.getTree();
        return Response.success(result);
    }

    @GetMapping("instList")
    @ApiOperation("查询逻辑设备实例列表")
    public Response<List<IcdConfigTypeInst>> instList(@Validated @NotNull(message = "iedName不能为空!") @Param("iedName") String iedName) throws Exception {
        List<IcdConfigTypeInst> result = bindService.instList(iedName);
        return Response.success(result);
    }

}
